import React from 'react';
import ReactDOM from 'react-dom';
import {
  useState,
  useCallback,
  useEffect,
} from 'react';
import { csv } from 'd3';

const width = window.innerWidth;
const height = window.innerHeight;

const circleRadious = 10;
const color = 'red';

// creating a json object to use aas the initial state
const initMouseLoc = {
  x: width / 2,
  y: height / 2,
};

const numss = [1, 2, 3];

const App = () => {
  // let us use useSate

  const [mouseLoc, setMouseLoc] = useState(
    initMouseLoc
  );

  const [data, setData] = useState(null);

  const [num, setNum] = useState(numss);

  // setMouseLoc is a fucntion to change the state
  // first time mouseLoc = initMouseLoc

  // to optimize this rerendring that happens on change of state we use callback(func,dependencies for fuction)
  // with call back the mouseMoveHandler does not get created evey single time

  // We may add event as an argument to get mouse information

  const mouseMoveHandler = useCallback(
    (event) => {
      console.log('this line executed');
      const { clientX, clientY } = event;
      //console.log({ clientX, clientY });

      setMouseLoc({
        x: clientX,
        y: clientY,
      });
    },
    [setMouseLoc]
  );
  // fetching the data
  const csvUrl =
    'https://raw.githubusercontent.com/Kafayatjumai/Cardiovascular-Disease-Dataset/main/cardio_clean.csv';

  const message = (data) => {
    data = data.slice(0, 100);

    var msg = '';

    msg =
      msg +
      'This file has ' +
      data.length +
      ' rows';
    msg =
      msg +
      ' Each row has ' +
      Object.keys(data[0]).length +
      ' features';

    return msg;
  };

  // csv(csvUrl).then((data) => {
  //   setData(data);
  // });

  // useEffect with no dependencies only runs its internal code ONCE
  useEffect(() => {
    // csv(csvUrl).then(data => (setData(data)));
    // More percise from:
    csv(csvUrl).then(setData);
  }, []);

  const addOne = useCallback(() => {
    //  setNum((curentNumeberAsaNamedFunction) => [
    setNum(() => [
      ...num,
      num.length + 1,
    ]);
  }, [num]);

  //   const addOne = useCallback(() => {
  //     setNum([...num , num.length+1])
  //    },[num]);

  return (
    <g>
      <button onClick={addOne}> Ok </button>
      <div>{num}</div>

      <svg
        width={width}
        height={height}
        // adding even lsitener on svg
        onMouseMove={mouseMoveHandler}
      >
        <text x="0" y="100" fill="red">
          {' '}
          Data is{' '}
          {data ? message(data) : 'loading'}{' '}
        </text>

        <text x="0" y="15" fill="red">
          I love SVG!
          <tspan dx="-100" dy="17">
            MouseX : {mouseLoc.x}{' '}
          </tspan>
          <tspan dx="-120" dy="17">
            {' '}
            MouseY : {mouseLoc.y}
          </tspan>
        </text>

        <circle
          cx={mouseLoc.x}
          cy={mouseLoc.y}
          r={circleRadious}
          fill={color}
        />
      </svg>
    </g>
  );
};

const rootElement = document.getElementById(
  'root'
);
ReactDOM.render(<App />, rootElement);
